## thunderbolt-tools 0.9.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(thunderbolt-user-space)

set(VERSION "0.9.1")

include(GNUInstallDirs)

set(UDEV_RULES_DIR "/lib/udev/rules.d" CACHE PATH "Install path for udev rules")
set(UDEV_BIN_DIR   "/lib/udev"         CACHE PATH "Install path for udev-triggered executables")
set(RULES_PREFIX   "60"                CACHE PATH "The numeric prefix for udev rules file")

set(TBT_CXXFLAGS ${CXX_FLAGS} -Wall -Wextra)

add_subdirectory(common)
add_subdirectory(tbtacl)
add_subdirectory(tbtadm)
add_subdirectory(docs)

set(PACKAGE_SUMMARY "User-space components for handling Thunderbolt controller and devices")

set(CPACK_RPM_COMPONENT_INSTALL ON)
set(CPACK_DEB_COMPONENT_INSTALL ON)
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
set(CPACK_STRIP_FILES ON)
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/Description")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set(CPACK_GENERATOR "DEB")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${PACKAGE_SUMMARY})
set(CPACK_PACKAGE_RELEASE 1)
set(CPACK_PACKAGE_CONTACT "Thunderbolt Software mailing list <thunderbolt-software@lists.01.org>")
set(CPACK_PACKAGE_VENDOR "Intel")
set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

# RPM specific
set(CPACK_PACKAGE_RELOCATABLE OFF)
set(CPACK_RPM_PACKAGE_REQUIRES "boost-program-options, boost-filesystem")
set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION "/lib"
                                                  "/lib/udev"
                                                  "/lib/udev/rules.d"
                                                  "/usr"
                                                  "/usr/share"
                                                  "/usr/share/doc"
                                                  "/usr/share/man"
                                                  "/usr/share/man/man1"
                                                  "/usr/bin")

# DEB specific
file(READ "${CPACK_PACKAGE_DESCRIPTION_FILE}" PACKAGE_DESCRIPTION)
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PACKAGE_DESCRIPTION})

# Main customization points
set(CPACK_PACKAGE_NAME ${PROJECT_NAME})
set(CPACK_PACKAGE_VERSION ${VERSION})
set(CPACK_PACKAGE_FILE_NAME
    "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-${CPACK_PACKAGE_RELEASE}.${CMAKE_SYSTEM_PROCESSOR}")

# For DEB
install(FILES ${CPACK_RESOURCE_FILE_LICENSE}
        DESTINATION share/doc/${CPACK_PACKAGE_NAME}
        RENAME copyright)

include(CPack)

=== docs/CMakeLists.txt ===
set(FILE_NAME tbtadm)
set(T2T_SOURCE "${FILE_NAME}.t2t")
set(MAN_OUTPUT "${FILE_NAME}.1.gz")

find_program(TXT2TAGS txt2tags)
if(${TXT2TAGS} STREQUAL "TXT2TAGS-NOTFOUND")
    message(FATAL_ERROR "txt2tags is needed for generating the man page")
endif()

add_custom_command(OUTPUT ${MAN_OUTPUT}
                   COMMAND txt2tags -t man -i "${CMAKE_CURRENT_SOURCE_DIR}/${T2T_SOURCE}" -o ${MAN_OUTPUT}.tmp
                   COMMAND gzip -9nc ${MAN_OUTPUT}.tmp > ${MAN_OUTPUT}
                   WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                   MAIN_DEPENDENCY ${T2T_SOURCE}
                   COMMENT "Generating man page...")
add_custom_target(manpage ALL DEPENDS ${MAN_OUTPUT})

install(FILES        "${CMAKE_CURRENT_BINARY_DIR}/${MAN_OUTPUT}"
        DESTINATION   ${CMAKE_INSTALL_MANDIR}/man1)

=== tbtadm/CMakeLists.txt ===
project(tbtadm VERSION 0.1 LANGUAGES CXX)

add_executable(${PROJECT_NAME} "main.cpp" "controller.cpp")
target_link_libraries(${PROJECT_NAME} PRIVATE common)

find_package(Boost REQUIRED COMPONENTS program_options)
target_link_libraries(${PROJECT_NAME} PRIVATE ${Boost_LIBRARIES})

target_compile_options(${PROJECT_NAME} PRIVATE
	$<$<COMPILE_LANGUAGE:CXX>:${TBT_CXXFLAGS}>)
set_property(TARGET ${PROJECT_NAME} PROPERTY CXX_STANDARD 14)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
thunderbolt-tools (0.9.1-1) unstable; urgency=medium

  * Update to upstream version 0.9.1

 -- Colin King <colin.king@canonical.com>  Wed, 6 Sep 2017 11:16:00 +0100

thunderbolt-tools (0.9-1) unstable; urgency=medium

  * Initial release (Closes: #855065)

 -- Mario Limonciello <mario.limonciello@dell.com>  Mon, 13 Feb 2017 14:04:07 -0600

=== debian/control ===
Source: thunderbolt-tools
Section: admin
Priority: optional
Maintainer: Colin King <colin.king@canonical.com>
Uploaders: Kamal Mostafa <kamal@whence.com>
Standards-Version: 4.0.0
Build-Depends: debhelper (>=9),
	       libboost-dev,
	       libboost-filesystem-dev,
	       libboost-program-options-dev,
	       cmake,
	       txt2tags
Homepage: https://github.com/01org/thunderbolt-software-user-space
Vcs-Git: https://github.com/01org/thunderbolt-software-user-space.git
Vcs-Browser: https://github.com/01org/thunderbolt-software-user-space

Package: thunderbolt-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Intel Thunderbolt userspace components
 Provides components for using Intel Thunderbolt controllers with
 security level features

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -pthunderbolt-tools -Bbuild_userspace -Scmake -D. --

override_dh_auto_build:
	dh_auto_build -pthunderbolt-tools -Bbuild_userspace

override_dh_auto_install:
	cp tbtacl/tbtacl.rules.in tbtacl/tbtacl.rules
	dh_auto_install --destdir debian/thunderbolt-tools -Bbuild_userspace

override_dh_auto_clean:
	rm -rf build*

## thunderbolt-tools 0.9.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(thunderbolt-user-space)

set(VERSION "0.9.2")

include(GNUInstallDirs)

include(FindPkgConfig)
pkg_get_variable(PKG_CONFIG_UDEV_DIR udev udevdir)

set(UDEV_RULES_DIR "${PKG_CONFIG_UDEV_DIR}/rules.d" CACHE PATH "Install path for udev rules")
set(UDEV_BIN_DIR   "${PKG_CONFIG_UDEV_DIR}"         CACHE PATH "Install path for udev-triggered executables")
set(RULES_PREFIX   "60"                             CACHE PATH "The numeric prefix for udev rules file")

set(TBT_CXXFLAGS ${CXX_FLAGS} -Wall -Wextra)

add_subdirectory(common)
add_subdirectory(tbtacl)
add_subdirectory(tbtadm)
add_subdirectory(docs)

set(PACKAGE_SUMMARY "User-space components for handling Thunderbolt controller and devices")

set(CPACK_RPM_COMPONENT_INSTALL ON)
set(CPACK_DEB_COMPONENT_INSTALL ON)
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
set(CPACK_STRIP_FILES ON)
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/Description")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set(CPACK_GENERATOR "DEB;RPM")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${PACKAGE_SUMMARY})
set(CPACK_PACKAGE_RELEASE 1)
set(CPACK_PACKAGE_CONTACT "Thunderbolt Software mailing list <thunderbolt-software@lists.01.org>")
set(CPACK_PACKAGE_VENDOR "Intel")
set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

# RPM specific
set(CPACK_PACKAGE_RELOCATABLE OFF)
set(CPACK_RPM_PACKAGE_REQUIRES "boost-program-options, boost-filesystem")

function(ALL_ANCESTOR_DIRS result dir)
    while(NOT dir STREQUAL "/")
      list(APPEND LOCAL_LIST "${dir}")
      get_filename_component(dir "${dir}/.." ABSOLUTE)
    endwhile()
    set(${result} "${LOCAL_LIST}" PARENT_SCOPE)
endfunction()

foreach(dir "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}"
            "${UDEV_RULES_DIR}"
            "${UDEV_BIN_DIR}"
            "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_MANDIR}/man1"
            "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/bash-completion/completions")
  ALL_ANCESTOR_DIRS(LIST_FOR_RPM "${dir}")
  list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION "${LIST_FOR_RPM}")
  list(REMOVE_DUPLICATES CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION)
endforeach()

# DEB specific
file(READ "${CPACK_PACKAGE_DESCRIPTION_FILE}" PACKAGE_DESCRIPTION)
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PACKAGE_DESCRIPTION})

# Main customization points
set(CPACK_PACKAGE_NAME ${PROJECT_NAME})
set(CPACK_PACKAGE_VERSION ${VERSION})
set(CPACK_PACKAGE_FILE_NAME
    "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-${CPACK_PACKAGE_RELEASE}.${CMAKE_SYSTEM_PROCESSOR}")

# For DEB
install(FILES ${CPACK_RESOURCE_FILE_LICENSE}
        DESTINATION share/doc/${CPACK_PACKAGE_NAME}
        RENAME copyright)

include(CPack)

=== tbtadm/CMakeLists.txt ===
--- 
+++ 
@@ -10,4 +10,8 @@
 	$<$<COMPILE_LANGUAGE:CXX>:${TBT_CXXFLAGS}>)
 set_property(TARGET ${PROJECT_NAME} PROPERTY CXX_STANDARD 14)
 
-install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
+install(TARGETS            ${PROJECT_NAME}
+        DESTINATION        ${CMAKE_INSTALL_BINDIR})
+install(FILES              ${PROJECT_NAME}.bash_completion
+        DESTINATION        ${CMAKE_INSTALL_DATAROOTDIR}/bash-completion/completions
+        RENAME             ${PROJECT_NAME})

=== debian/changelog ===
thunderbolt-tools (0.9.2-2) unstable; urgency=medium

  * Update Standards-Version to 4.1.2
  * debian/control Remove erroneous Vcs-Git and Vcs-Browser (Closes: #883859)
    - there are no upstream repos for the packaging at present, so
      remove these

 -- Colin King <colin.king@canonical.com>  Fri, 8 Dec 2017 14:17:44 +0000

thunderbolt-tools (0.9.2-1) unstable; urgency=medium

  * Update to upstream version 0.9.2
  * Set architecture to just linux-any as these tools are not applicable
    for kfreebsd-amd64, kfreebsd-i386
  * Update Standards-Version to 4.1.1
  * Add udev and pkg-config to Build-Depends as cmake now does smarter
    build-time configuration

 -- Colin King <colin.king@canonical.com>  Thu, 23 Nov 2017 15:01:11 +0000

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -pthunderbolt-tools -Bbuild_userspace -Scmake -D. --
+	dh_auto_configure -pthunderbolt-tools -Bbuild_userspace -Scmake -D. -- -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr
 
 override_dh_auto_build:
 	dh_auto_build -pthunderbolt-tools -Bbuild_userspace

## thunderbolt-tools 0.9.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(thunderbolt-user-space)
 
-set(VERSION "0.9.2")
+set(VERSION "0.9.3")
 
 include(GNUInstallDirs)
 
@@ -17,8 +17,43 @@
 
 add_subdirectory(common)
 add_subdirectory(tbtacl)
+add_subdirectory(tbtxdomain)
 add_subdirectory(tbtadm)
 add_subdirectory(docs)
+
+configure_file(tests/test-integration-mock.py tests/test-integration-mock.py COPYONLY)
+configure_file(tests/Dockerfile tests/Dockerfile COPYONLY)
+
+add_custom_target(check
+	COMMAND umockdev-wrapper python3 tests/test-integration-mock.py
+	DEPENDS tests/test-integration-mock.py tbtadm
+)
+
+set(DOCKER_IMAGE "thunderbolt-tools")
+
+set(DOCKER_BUILD_CMD
+	docker build
+	--tag ${DOCKER_IMAGE}
+	--file tests/Dockerfile
+	.
+)
+add_custom_target(docker-build
+	COMMAND ${DOCKER_BUILD_CMD}
+	DEPENDS tests/Dockerfile
+)
+
+set(DOCKER_RUN_CMD
+	docker run
+	--env
+	--tty
+	--volume ${CMAKE_CURRENT_LIST_DIR}:/usr/local/src/thunderbolt-tools
+	${DOCKER_IMAGE}
+	/bin/bash tests/docker-build.sh
+)
+add_custom_target(docker-run
+	COMMAND ${DOCKER_RUN_CMD}
+	DEPENDS tests tbtadm
+)
 
 set(PACKAGE_SUMMARY "User-space components for handling Thunderbolt controller and devices")
 
@@ -37,7 +72,7 @@
 
 # RPM specific
 set(CPACK_PACKAGE_RELOCATABLE OFF)
-set(CPACK_RPM_PACKAGE_REQUIRES "boost-program-options, boost-filesystem")
+set(CPACK_RPM_PACKAGE_REQUIRES "boost-filesystem")
 
 function(ALL_ANCESTOR_DIRS result dir)
     while(NOT dir STREQUAL "/")

=== common/CMakeLists.txt ===
project(common VERSION 0.1 LANGUAGES CXX)

add_library(${PROJECT_NAME} STATIC "file.cpp")

find_package(Boost REQUIRED COMPONENTS filesystem)
target_link_libraries(${PROJECT_NAME} PUBLIC ${Boost_LIBRARIES})

target_include_directories(${PROJECT_NAME} INTERFACE
	$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

target_compile_options(${PROJECT_NAME} PRIVATE
	$<$<COMPILE_LANGUAGE:CXX>:${TBT_CXXFLAGS}>)
set_property(TARGET ${PROJECT_NAME} PROPERTY CXX_STANDARD 14)

=== tbtacl/CMakeLists.txt ===
set(TBTACL "tbtacl")
project(${TBTACL}-write VERSION 0.1 LANGUAGES CXX)
set(TBTACL_RULES "${RULES_PREFIX}-${TBTACL}.rules")

add_executable(${PROJECT_NAME} "write.cpp")
target_link_libraries(${PROJECT_NAME} PRIVATE common)

target_compile_options(${PROJECT_NAME} PRIVATE
	$<$<COMPILE_LANGUAGE:CXX>:${TBT_CXXFLAGS}>)
set_property(TARGET ${PROJECT_NAME} PROPERTY CXX_STANDARD 14)

configure_file("${TBTACL}.in"       ${TBTACL}       @ONLY)
configure_file("${TBTACL}.rules.in" ${TBTACL_RULES} @ONLY)

install(TARGETS              ${PROJECT_NAME}
        RUNTIME DESTINATION  ${UDEV_BIN_DIR})
install(PROGRAMS            "${CMAKE_CURRENT_BINARY_DIR}/${TBTACL}"
        DESTINATION          ${UDEV_BIN_DIR})
install(FILES               "${CMAKE_CURRENT_BINARY_DIR}/${TBTACL_RULES}"
        DESTINATION          ${UDEV_RULES_DIR})

=== tbtadm/CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,6 @@
 
 add_executable(${PROJECT_NAME} "main.cpp" "controller.cpp")
 target_link_libraries(${PROJECT_NAME} PRIVATE common)
-
-find_package(Boost REQUIRED COMPONENTS program_options)
-target_link_libraries(${PROJECT_NAME} PRIVATE ${Boost_LIBRARIES})
 
 target_compile_options(${PROJECT_NAME} PRIVATE
 	$<$<COMPILE_LANGUAGE:CXX>:${TBT_CXXFLAGS}>)

=== tbtxdomain/CMakeLists.txt ===
set(TBTXDOMAIN "tbtxdomain")
set(TBTXDOMAIN_RULES "${RULES_PREFIX}-${TBTXDOMAIN}.rules")

configure_file("${TBTXDOMAIN}.in" ${TBTXDOMAIN} @ONLY)
configure_file("${TBTXDOMAIN}.rules.in" ${TBTXDOMAIN_RULES} @ONLY)

install(PROGRAMS            "${CMAKE_CURRENT_BINARY_DIR}/${TBTXDOMAIN}"
        DESTINATION          ${UDEV_BIN_DIR})
install(FILES               "${CMAKE_CURRENT_BINARY_DIR}/${TBTXDOMAIN_RULES}"
        DESTINATION          ${UDEV_RULES_DIR})

=== debian/changelog ===
thunderbolt-tools (0.9.3-8) unstable; urgency=medium

  * Orphan upload
  * Update Maintainer field to Debian QA Group <packages@qa.debian.org>
    so package can be orphaned
  * Update Standards-Version to 4.7.2
  * Update build-depdends, use pkgconf
  * Update debian packaging copyright to 2025

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 15 Sep 2025 13:23:13 +0100

thunderbolt-tools (0.9.3-7) unstable; urgency=medium

  * Replace dependency on udev with systemd-dev (Closes: #1060547)
  * debian/control: update standards version to 4.6.2
  * debian/changelog: update copyright year
  * debian/rules: add missing hardening flags

 -- Colin Ian King <colin.i.king@gmail.com>  Fri, 12 Jan 2024 14:47:48 +0000

thunderbolt-tools (0.9.3-6.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Skip duplicate installation of tbtacl-write. (Closes: #1058828)

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 24 Dec 2023 14:13:22 +0100

thunderbolt-tools (0.9.3-6) unstable; urgency=medium

  * Roll in all fixes since 0.9.3, project is now in maintainence
    mode, so pull in all fixes as we don't expect another tagged
    release from Intel.
  * debian/control: Update maintainer email address
  * debian/control: Update standards version to 4.6.1
  * debian/copyright: Update email addresses

 -- Colin Ian King <colin.i.king@gmail.com>  Wed, 14 Dec 2022 12:42:55 +0000

thunderbolt-tools (0.9.3-5) unstable; urgency=medium

  * Debian/control: remove compat file, add Rules-Requires-Root rule

 -- Colin King <colin.king@canonical.com>  Sat, 4 Jul 2020 20:55:11 +0100

thunderbolt-tools (0.9.3-4build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 21:47:37 +0000

thunderbolt-tools (0.9.3-4) unstable; urgency=medium

  * Pull in a couple of upstream fixes:
    - 88a971ad290d tbtadm: check sysfs device file for thunderbolt
                   device first.
    - cdd7215accc4 Make tbtacl safer to use with untrusted input

 -- Colin King <colin.king@canonical.com>  Fri, 19 Oct 2018 16:50:53 +0100

thunderbolt-tools (0.9.3-3) unstable; urgency=medium

  * Remove redundant copy of udev rules (LP: #1762187)

 -- Colin King <colin.king@canonical.com>  Sun, 8 Apr 2018 15:43:12 +0100

thunderbolt-tools (0.9.3-2) unstable; urgency=medium

  * Set UDEV_BIN_DIR to /lib/udev (LP: #1761757)

 -- Colin King <colin.king@canonical.com>  Fri, 6 Apr 2018 14:52:11 +0100

thunderbolt-tools (0.9.3-1) unstable; urgency=medium

  * Update to upstream version 0.9.3
  * debian/compat: update to 11
  * debian/control: update debhelper to >= 11

 -- Colin King <colin.king@canonical.com>  Wed, 14 Feb 2018 10:02:01 +0000

=== debian/control ===
Source: thunderbolt-tools
Rules-Requires-Root: no
Section: admin
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Standards-Version: 4.7.2
Build-Depends: debhelper (>=13),
               debhelper-compat (=13),
	       libboost-dev,
	       libboost-filesystem-dev,
	       libboost-program-options-dev,
	       cmake,
               pkgconf,
               systemd-dev,
	       txt2tags
Homepage: https://github.com/01org/thunderbolt-software-user-space

Package: thunderbolt-tools
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Intel Thunderbolt userspace components
 Provides components for using Intel Thunderbolt controllers with
 security level features

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,8 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
 
 %:
 	dh $@
@@ -10,7 +14,6 @@
 	dh_auto_build -pthunderbolt-tools -Bbuild_userspace
 
 override_dh_auto_install:
-	cp tbtacl/tbtacl.rules.in tbtacl/tbtacl.rules
 	dh_auto_install --destdir debian/thunderbolt-tools -Bbuild_userspace
 
 override_dh_auto_clean:
